package demojsoncrud.servlets;

import demojsoncrud.services.PersonaService;
import static demojsoncrud.utilities.CustomHttpServletRequest.getBodyJsonObject;
import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.json.JSONObject;

public class PersonaServlet extends HttpServlet {

    @Override
    protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        String param = request.getParameter("accion");
        switch (param) {
            case "listarPersona":
                listarPersona(request, response);
                break;
            case "registrarPersona":
                registrarPersona(request, response);
                break;
            case "editarPersona":
                editarPersona(request, response);
                break;
            case "cambiarEstado":
                cambiarEstado(request, response);
                break;
            default:
                response.setContentType("application/json");
                PrintWriter pw = response.getWriter();
                JSONObject respuesta = new JSONObject();
                respuesta
                    .put("status", false)
                    .put("message", "No existe la url solicitada.")
                    .put("data", "");
                pw.print(respuesta);
                break;
        }
    }

    private void listarPersona(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("application/json");
        PrintWriter pw = response.getWriter();
        PersonaService service = new PersonaService();

        String draw = request.getParameter("draw");
        String start = request.getParameter("start");
        String length = request.getParameter("length");
        String search = request.getParameter("search");

        JSONObject json = service.listarPersona(search, draw, start, length);
        pw.print(json);
    }

    private void registrarPersona(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("application/json");
        PrintWriter pw = response.getWriter();
        PersonaService service = new PersonaService();
        JSONObject datos = new JSONObject();
        datos = getBodyJsonObject(request);
        JSONObject respuesta = service.registrarPersona(datos.getJSONObject("json"));
        pw.print(respuesta);

    }

    private void editarPersona(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("application/json");
        PrintWriter pw = response.getWriter();
        PersonaService service = new PersonaService();
        JSONObject datos = new JSONObject();
        datos = getBodyJsonObject(request);
        JSONObject respuesta = service.editarPersona(datos.getJSONObject("json"));
        pw.print(respuesta);
    }

    private void cambiarEstado(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("application/json");
        PrintWriter pw = response.getWriter();
        PersonaService service = new PersonaService();
        JSONObject datos = new JSONObject();
        datos = getBodyJsonObject(request);
        JSONObject respuesta = service.cambiarEstado(datos.getJSONObject("json"));
        System.out.println(respuesta);
        pw.print(respuesta);
    }

}
