package demojsoncrud.servlets;

import demojsoncrud.services.UbigeoService;
import static demojsoncrud.utilities.CustomHttpServletRequest.getBodyJsonObject;
import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.json.JSONObject;

public class UbigeoServlet extends HttpServlet {

    @Override
    protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        String param = request.getParameter("accion");
        response.setCharacterEncoding("UTF-8");
        if ("listarDepartamento".equals(param)) {
            listarDepartamento(request, response);
        } else if ("listarProvincia".equals(param)) {
            listarProvincia(request, response);
        } else if ("listarDistrito".equals(param)) {
            listarDistrito(request, response);
        }
    }

    private void listarDepartamento(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("application/json");
        PrintWriter pw = response.getWriter();
        UbigeoService service = new UbigeoService();
        JSONObject json = service.listarDepartamento();
        pw.print(json);
    }

    private void listarProvincia(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("application/json");
        PrintWriter pw = response.getWriter();
        UbigeoService service = new UbigeoService();
        JSONObject datos = new JSONObject();
        datos = getBodyJsonObject(request);
        JSONObject respuesta = service.listarProvincia(datos.getJSONObject("json"));
        pw.print(respuesta);
    }

    private void listarDistrito(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("application/json");
        PrintWriter pw = response.getWriter();
        UbigeoService service = new UbigeoService();
        JSONObject datos = new JSONObject();
        datos = getBodyJsonObject(request);
        JSONObject respuesta = service.listarDistrito(datos.getJSONObject("json"));
        pw.print(respuesta);
    }

}
